#ifndef EIGEN_HH
#define EIGEN_HH

#include "pic.hh"
#include "intensity.hh"

class eigen : public pic
{

public:
  
  eigen(char	*name);		// new and load
  ~eigen();

  void
    load();                     // load eigenvalues

  void
    load(int	index);		// load the nth image

  void
    load_all() { 
      load();   
      for (int i=0; i < count_; i++) load(i);
    };
  
  char*
    type() { return "EIGEN-BASE"; }

  void				// compute the distance from face space metric
    d_f_s(intensity	&image, int dimensionality);

  intensity *
    image(int	index) { return images_[index]; }

  intensity	*
    dfs() { return dfs_; }

private:

  void
    get_info(); 		// Get info from path/README file

  int		count_;		// the number of images in basis
  char		*path_;		// the path to the images
  intensity	*dfs_;		// it's dfs metric see d_f_s()
  intensity	**images_;	// each basis image
  float         *eigenvalues_;	// each basis image
};


#endif
