#include "gif.hh"

#include <stdio.h>
#include <iostream.h>

#include "intensity.hh"

// ------------------------------------- constructors

gif::gif(char	*name)
{
  FILE		*fp;

  if ((fp=fopen(name, "rb")) == NULL) // First, can we open the file?
    return;

  fileName_ = new char[strlen(name)+1]; // Copy the name for later
  strcpy(fileName_, name);
  
  // Allocate space for the name of the picture

  unsigned char *	data;

  // data is allocated inside ReadGIF
  data    = ReadGIF(fp, width_, height_, colors_, bg_color_);
  fclose(fp);

  if (data == NULL)
    cout <<" Data is NULL" << endl;
  size_ = height_ * width_;

  bw_ = 0;
  aux(data);

  valid_ = true;
  info();
}

gif::gif(intensity	*img)
{
  unsigned char	*image;
  float		*data;
  
  height_  = img->height();
  width_   = img->width();
  data     = img->data();

  fileName_= NULL;
  size_     = width_*height_;

  image = new unsigned char[size_];
  aux(image);
  
  img->normalize();

  for (int i=size_; i; --i, image++, data++)
    *image = (unsigned char )(*data * 255.0);
  
  bw_ = 1;			// intensity image.. no colors
  valid_ = true;
  info();
}

gif::~gif()
{
  
  if (fileName_)
    delete fileName_;

  if (valid_)
    {
      delete *image_;
      delete image_;
    }
}

// -------------------------------------------- helpers

void
gif::aux(unsigned char*	data)
{
  // Allocate space for all lines and store pointers into the data
  image_   = new unsigned char *[height_];

  for (int i=0; i < height_; i++)
    image_[i] = data+i*width_;

}

void
gif::save(char	*name)
{
  FILE		*fp;

  if (!valid_)
    return;
  
  if ((fp=fopen(name, "wb")) == NULL)
    {
      return;
    }

  WriteGIF(fp, width_, height_, colors_, image_[0], bw_);
  fclose(fp);
}



