#include <X11/Intrinsic.h>
#include <stdio.h>



FILE *Fd;

void compress(unsigned char *Data, int Count);

void
WriteGIF(FILE 		*fd,
	 int 		width,
	 int 		height,
	 XColor 	*colrs,
	 unsigned char 	*data,
	 int		bw_color=0 )
{
  
  Fd=fd;

  /* Write GIF header */
  fwrite("GIF87a",1,6,Fd);
  fputc(width & 0xff, Fd);
  fputc((width/256) & 0xff, Fd);
  fputc(height & 0xff, Fd);
  fputc((height/256) & 0xff, Fd);
  fputc(0xf7, Fd);
  fputc(0, Fd);
  fputc(0, Fd);
  
  /* Write GIF colormap */
  for (int i=0; i<256; i++)
    if (bw_color)
      {    			/* Gray scale */
	fputc( (unsigned char)i, Fd);
	fputc( (unsigned char)i, Fd);
	fputc( (unsigned char)i, Fd);
      }
    else
      {
	fputc( colrs[i].red, Fd);
	fputc( colrs[i].green, Fd);
	fputc( colrs[i].blue, Fd);
      }


  
  /* Write GIF subheader */
  fputc(',', Fd);
  fputc(0, Fd);
  fputc(0, Fd);
  fputc(0, Fd);
  fputc(0, Fd);
  fputc(width & 0xff, Fd);
  fputc((width/256) & 0xff, Fd);
  fputc(height & 0xff, Fd);
  fputc((height/256) & 0xff, Fd);
  fputc(0, Fd);
  fputc(8, Fd);
  
  /* Write GIF pixels */
#ifdef DEBUG
  printf("About to compress\n");
#endif

  compress(data,width*height);
  
  /* Write GIF terminator */
  fputc(0, Fd);
  fputc(';', Fd);
  
  /* Close output image */
//  im_free1D((char *)Data1);
  fclose(Fd);
}
