#ifndef intensity_hh
#define intensity_hh

#include "pic.hh"
#include "gif.hh"

class intensity: public pic
{
public:
  
  intensity(gif		&GIF);		// translate
  intensity(char *      filename);      // URS: init from file
  intensity(intensity	&inten);

  intensity(int		width, 	int		height,
	    intensity		&inten, 
	    int		st_x=0, int	st_y=0);

  intensity(int		width, int	height,	float 		*data=NULL);
  intensity(int		width, int	height, unsigned char	*data);

  intensity *
    reduce34(intensity	&RHS);

  intensity *
    sample(float factor);

  intensity *
    interpolate( float factor);

  intensity &
    operator+(float	RHS);

   intensity &
   operator-(float);

  intensity &
    operator-=(float);

  intensity &
    operator -=(intensity *);

  intensity &
    operator +=(intensity *);

  intensity &
    operator /=(float );

  intensity &
    operator*(float);

  intensity &
    operator/(float);

  float
    energy();
  
  float
    project(intensity	*img);

  char *
    type() { return "INTENSITY"; }
   
  ~intensity();
   
  float *
    data() { return n_image_[0]; }

  float **
    matrix() { return n_image_; }

  float **
    nr_matrix(); 

  float *
    operator[](int h) { return n_image_[h];}

  intensity &
    normalize();

  intensity &
    umap();

  intensity &			// kron tensor product
    kron(intensity	&y);

  void
    set(int	x,int	y, float	val) { n_image_[y][x]=val; }

  void 
     save(char * file) ;

protected:

  float		**n_image_;

private:

  void
    aux_init( int		width, int	height,	float	*data);
  
  void
    aux2(unsigned char	*data);
};


#endif				// intensity_hh
