#ifndef PIC_HH
#define PIC_HH

#include "defs.hh"

#include <stdio.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <iostream.h>

class pic 
{
public:
  
  pic() {  valid_ = onDisplay_ = false; }
  ~pic() { };

  void
    display();

  int 
    height() { return height_; }

  int
    width() { return width_; }

  virtual char *
      type() { return "Pic_Type"; }  
  
  void
    info() { 
      if (verbose_)
	cout << type() << " size: " << width_ << " X "<< height_ << endl;
    }

  static void
    verbose() { verbose_=1; }

  static void
    quiet() { verbose_=0; }

				// Enable this routine with code to
				// draw a rectangle around image 
//  draw_outline();
  
protected:

  static
    int		verbose_;

  int		height_;
  int		width_;
  boolean	onDisplay_;
  boolean	valid_;
  int		size_;
};

#endif				// PIC_HH
