#ifndef PYRAMID_HH
#define PYRAMID_HH

#include "pic.hh"
#include "eigen.hh"
#include "intensity.hh"

#define MAX_TAPS 9

float *
    gauss_filter(float scalefact, int numtaps);

class pyramid : public pic 
{

public:
  
  pyramid(intensity &image);            // new and load

  pyramid(intensity &image, float scale); // new and load

  pyramid(eigen epic, pyramid inppyr);        

     // NOTE: this does not really correspond to the concept of a gaussian 
     // pyramid. Given a basis of vectors and a pyramid of the input image
     // this function constructs a pyramid of distance maps, each
     // corresponding to a particular scale of the input image.

  ~pyramid();

  char*
    type() { return "PYRAMID"; }

  intensity *
    image(int	index) { return images_[index]; }

  int
    levels() { return count_; }

  void 
    found_face(pyramid image_pyr);

private:

  int		count_;		// the number of images in pyramid
  intensity	**images_;	// each basis image

//  static float *g_filters[MAX_TAPS+1];
  static float * g_filter;
  static int  g_filter_taps;
};


#endif
